// client.h                          
// v0.84 (7.3.2002)
// (c) 2002 Andreas Krueger
//
// Please, if you change anything in this code,
// mark the end of those lines with '// *+* your name *+* ' 
// (so that I can find it) and send the code 
// to cye-code@AndreasKrueger.de
//
// last change: 
//          by:


// used the qt example as a basis 

/****************************************************************************
** $Id:  qt/client.cpp   3.0.1   edited Nov 5 19:12 $
**
** Copyright (C) 1992-2000 Trolltech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/

#ifndef CLIENT_H
#define CLIENT_H

#include <qapplication.h>
#include <qvbox.h>
#include <qhbox.h>
#include <qtextview.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qpushbutton.h>
#include <qtextstream.h>
#include <qtimer.h>
#include <qsocket.h>
#include "dialogs.h"
#include "storage.h"
typedef ClientStorage myData;

class Client : public QVBox {
    Q_OBJECT
public:
	Client(myData * DataPointer, Dialogs * aDialogsPointer, QWidget * parent=0, const char * name=0);
	void initClient(const QString &host, Q_UINT16 port);

private slots:
	void quit();
	void openConnection();
	void sendToServer();
	void closeConnection();
	void socketHostFound();
	void HostNotFoundInDNS();
    void socketConnected();
	void ServerNotFound();
    void socketConnectionClosed();
    void socketClosed();
    void socketError( int e );
    void socketReadyRead();
	void explainProblem(int reason);
	void setHost();
	void CloseTheConnection(int GoodbyeReason);
	void clearView();
	void TESTToggleOpenSendProcessAnswerClose(bool);
	void TESTSendWrongFormatToServer();
	void TESTSendOldVersionToServer();
	void TESTSendTooNewVersionToServer();
	void TESTSendTooMuchToServer();

private:
    QSocket     *theSocket;
	QWidget		*myParent;
	bool		uploadSuccessful;
	myData		*DataStoragePointer;
	Dialogs		*DialogsPointer;
    QTextView	*infoText;
    QLineEdit	*inputText;
	QString		servername;
	Q_UINT16	serverport;
	Q_UINT32	theSize;
	bool		HeaderRead;
	QLineEdit	*editHostaddress;
	QLineEdit	*editHostport;
	QTimer		*DNSTimer;
	QTimer		*ConnectTimer;
	bool        hostnameFound;
	bool        serverConnected; 
	QPushButton *open;

	// testing only:
	bool		noWait;         // if that is true, the one button send works
	QGroupBox	*TESTsendBox;
	QLineEdit	*TESTInputTime;
	QDataStream TESTOutStream;
	myData		TESTDataItem;
	Q_UINT32	TESTSendCounter;

signals:
	void IllegalConnection(int GoodbyeReason);
	void ClientProblem(int GoodbyeReason);
	void Event(QString eventname);

};


#endif CLIENT_H
