// invitation.cpp
// v0.98 (3.5.2002)
// (c) 2002 Andreas Krueger
//
// Please, if you change anything in this code,
// mark the end of those lines with '// *+* your name *+* ' 
// (so that I can find it) and send the code 
// to cye-code@AndreasKrueger.de
//
// last change: 
//          by:

#include "constants.h"
#include "helpers.h"

#include <string>
using std::string;

#include "invitation.h"

void InvitedPerson::fromListViewItem(QListViewItem *i){
	name=i->text(0).latin1();
	email=i->text(1).latin1();
	bool ok=true;
	coin=i->text(2).toShort(&ok, 10);
	uploaded=(i->text(3)=="no")?false:true;
}

QListViewItem* InvitedPerson::toListViewItem(QListView* parent){
	QString coinstr; coinstr.setNum(coin);
	QListViewItem *temp=new QListViewItem(parent, 
		QString(name.c_str()), QString(email.c_str()), coinstr, (uploaded)?"yes":"no");
	return temp;
}

void fromListViewToValueList(QListView *LV, QValueList<InvitedPerson > &lip){
	lip.clear();
    QListViewItem * lv = LV->firstChild();
	InvitedPerson ip;
    while( lv ) {
		ip.fromListViewItem(lv);
		lip.append(ip);
        lv = lv->nextSibling();
    }
}

void fromValueListToListView(QValueList<InvitedPerson > &lip, QListView *LV){
	for (QValueList<InvitedPerson >::Iterator it=lip.begin(); it!=lip.end(); it++){
		(*it).toListViewItem(LV);
	}
}

QTextStream& operator<<(QTextStream &s, QValueList<InvitedPerson > &lip){
	s << (Q_UINT16) lip.count();
	for (QValueList<InvitedPerson >::Iterator it=lip.begin(); it!=lip.end(); it++){
		s<<(*it).name;
		s<<(*it).email;
		s<<(*it).coin;
		s<<(Q_UINT8) (*it).uploaded;
	}
	return s;
}

QDataStream& operator<<(QDataStream &s, QValueList<InvitedPerson > &lip){
	s << (Q_UINT16) lip.count();
	for (QValueList<InvitedPerson >::Iterator it=lip.begin(); it!=lip.end(); it++){
		s<<(*it).name;
		s<<(*it).email;
		s<<(*it).coin;
		s<<(Q_UINT8) (*it).uploaded;
	}
	return s;
}

QDataStream& operator>>(QDataStream &s, QValueList<InvitedPerson > &lip){
	Q_UINT16 num;
	s >>num;
	string name, email; Q_UINT8 coin,uploaded;
	for (Q_UINT16 i=0; i<num; i++){
		s>>name;
		s>>email;
		s>>coin;
		s>>uploaded;
		lip.append(InvitedPerson(name,email,coin, (bool)uploaded));
	}
	return s;
}

#include <strstream>
using std::ostrstream;

char* printTheNotYetUploadedIntoSQLTriple(QValueList<InvitedPerson > &lip, 
										  string fourthcolumn,
										  int &NumNotYetUploaded){
	
	QValueList<InvitedPerson >::Iterator it;

	ostrstream ss;

	NumNotYetUploaded=0;
	
	for (it=lip.begin(); it!=lip.end();it++){ 
		if(!(*it).uploaded){
			ss<<"('"<<(*it).name<<"','"<<(*it).email<<"',";
			ss<<(int)(*it).coin<<fourthcolumn<<"),";
			NumNotYetUploaded ++;
		}
	}
	if (NumNotYetUploaded != 0)
		ss.seekp(ss.tellp()-(long)1); // cut out the last comma
	ss<<'\0';
	// qDebug("%s",ss.str());
	return ss.str();
}


void setAllUploadedTrue(QValueList<InvitedPerson > &lip){
	QValueList<InvitedPerson >::Iterator it;
	for (it=lip.begin(); it!=lip.end();it++){ 
		// bool testit=(*it).uploaded;
		(*it).uploaded=true;
	}
}


////////////////////////////////////////// 
// class Invitations
//    the Dialogwindow and the ListView!
//////////////////////////////////////////

Invitations::Invitations( QWidget *parent, const char *name )
        : QHBox( parent, name )
{
	QVBox *inbx=new QVBox(this, "inputbox");
	QLabel *intro=new QLabel("Invite by cyemail to join the project and "
		"to mention \nYOUR membernumber as their recommender.\n", inbx, "hello");
	intro->setAlignment(AlignCenter | AlignVCenter);
	QHBox *hb1=new QHBox(inbx,"input");
	QVBox *namebx=new QVBox(hb1, "namebox");
	QLabel *lname; lname=new QLabel("Name", namebx,"labelname");
	editname=new QLineEdit("", namebx,"labelname");
	QVBox *emailbx=new QVBox(hb1, "emailbox");
	QLabel *lemail; lemail=new QLabel("eMail", emailbx,"labelemail");
	editemail=new QLineEdit("", emailbx,"email");
	QVBox *coinbx=new QVBox(hb1, "coinbox");
	QLabel *labelcoin; labelcoin=new QLabel("Coin", coinbx,"labelcoin");
	editcoin=new QLineEdit("0", coinbx,"coin");
	editcoin->setEnabled(false);
	QFont font(this->font());
    QFontMetrics fm(font);
	coinbx->setFixedWidth(fm.width("99999"));

	QVBox *insbuttbx=new QVBox(hb1, "insertbuttonbox");
	QLabel *fakeLabelForInsertButton; fakeLabelForInsertButton=new QLabel(" ", insbuttbx,"labelinsbutton");
	QPushButton *insert=new QPushButton("&insert", insbuttbx,"button insert");
	//insert->setSizePolicy(QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::MinimumExpanding));
	invited=new QListView(inbx, "invited people listview");

	QHBox *hb2=new QHBox(inbx,"remove box");
	QPushButton *remove=new QPushButton("remove", hb2,"button remove");
	info=new QLabel("", hb2,"info label");
	info->setAlignment(AlignCenter | AlignVCenter);
	//remove->setSizePolicy(QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::MinimumExpanding));

	inbx->setFixedWidth(400);

	QVBox *favcoinbx=new QVBox(this, "favourite coin box");
	labfav=new QLabel("Send your favourite coin\nin the cyemail postcard:", favcoinbx, "hello");
	labfav->setAlignment(AlignCenter | AlignVCenter);
	theCoinShow=new SlideShow(favcoinbx, "coinshow");
	QPushButton *ok=new QPushButton ("OK", this, "ok button");
	ok->setSizePolicy(QSizePolicy( QSizePolicy::MinimumExpanding, QSizePolicy::MinimumExpanding));
	connect (ok, SIGNAL (clicked()) , this, SIGNAL (ok()) );
	
	invited->addColumn("Name");invited->addColumn("eMail");
	invited->addColumn("Coin");invited->addColumn("uploaded");

	connect (insert, SIGNAL(clicked()), this, SLOT(insertPerson()) );
	connect (remove, SIGNAL(clicked()), this, SLOT(removePerson()) );

	//QPushButton *test=new QPushButton("test",this,"test");
	//connect (test, SIGNAL(clicked()), this, SLOT(test()) );
	connect (theCoinShow, SIGNAL(focusChanged(uint, uint)), this, SLOT(CoinChanged()) );
	connect (theCoinShow, SIGNAL(Event(QString)), this, SLOT(processEvents(QString)) );
}
void Invitations::processEvents(QString event){
	emit Event("Invitation"+event);
}

void Invitations::CoinChanged(){
	//labfav->setText(tr("Send your favourite coin in\nthe cyemail postcard: %1")
	//	.arg(theCoinShow->actualCoinNumber()));
	editcoin->setText(tr("%1").arg(theCoinShow->actualCoinNumber()));
}

void Invitations::setFavouriteCoin(uint CoinNumber){
	theCoinShow->switchToCoinNumber(CoinNumber);
	editcoin->setText(tr("%1").arg(CoinNumber));
}

#include "helpers.h"

void Invitations::insertPerson(){
	if (!isEmail(editemail->text())){
		QString error=editemail->text();
		// error=(error.isEmpty())?"This ":("'"+error+"'\n");
		if (error.isEmpty()){
			error="This ";
		}
		else{
			error=("'"+error+"'\n");
		}
		error+="is not a valid\nemail@address.tv";
		info->setText(error);
		info->setPalette( QPalette( QColor(100, 180, 200) ) );
		emit Event("InvitationNoValidEmailAddress");
	}
	else {
		info->setText("");
		info->unsetPalette();
		QString coinnumber; 
		coinnumber.setNum(theCoinShow->actualCoinNumber());
		QListViewItem *pers; pers=new QListViewItem(invited, 
			editname->text(), editemail->text(), coinnumber, "no");
		emit Event("InvitationPersonInserted");
	}
}

void Invitations::removePerson(){
	QListViewItem *curr=invited->currentItem();
	if (curr<=0){
		info->setText("first click the to\nbe deleted person");
		info->setPalette( QPalette( QColor(150, 80, 255) ) );
		emit Event("InvitationDidNotRemovePersonCauseNoneSelected");
		return;
	}
	if (curr->text(3)=="yes"){
		info->setText("Sorry, that invitation\nwas already uploaded.");
		info->setPalette( QPalette( QColor(80, 150, 255) ) );
		emit Event("InvitationDidNotRemovePersonCauseAlreadyUploaded");
		return;
	}

	delete curr;
	info->setText("");
	info->unsetPalette();
	emit Event("InvitationRemovedPerson");
}


#include <qfile.h>

void Invitations::test(){
	QValueList<InvitedPerson > lip;
	fromListViewToValueList(invited, lip);
	//printTheNotYetUploadedIntoSQLTripel(lip, ",NOW()");
	
    QFile f( "test.lvi");
    f.open( IO_WriteOnly );
	if (f.status()!=IO_Ok) {
		qDebug("Some error opening file");
		return;
	}
    QDataStream s( &f );
	s << lip;
	f.close();

	lip.clear();
	invited->clear(); 

    bool ok=f.open( IO_ReadOnly );
	if (!ok) {
		qDebug("file open error ");
		return ;
	}
    //QDataStream s( &f );

    s>>lip;

	fromValueListToListView(lip, invited);

}


// these two crash, but why?:

void Invitations::writeInvitedPersonsToStream(QTextStream& qts){
	qDebug("ATTENTION: buggy! Rather not use writeInvitedPersonsToStream()");
    
    QListViewItem * i = invited->firstChild();
    while( i ) {
		qts<<i->text(0)<<"<"<<i->text(1)<<">";
		qts<< "(coin:"<<i->text(2)<<"; uploaded:"<<i->text(3);

        i = i->nextSibling();
    }
}

void Invitations::writeInvitedPersonsToStream(QDataStream& qds){
	qDebug("ATTENTION: buggy! Rather not use writeInvitedPersonsToStream()");
    
    QListViewItem * i = invited->firstChild();
    while( i ) {
		qds<<i->text(0)<<"<"<<i->text(1)<<">";
		qds<< "(coin:"<<i->text(2)<<"; uploaded:"<<i->text(3);

        i = i->nextSibling();
    }
}
